#pragma once
#include "../component.h"
#include <string>

namespace ecs {

class ModelPathComponent : public Component {
public:
    ModelPathComponent() = default;
    explicit ModelPathComponent(const std::wstring& path) : m_path(path) {}
    ~ModelPathComponent() = default;

    void Initialize() override {}
    void Update(float deltaTime) override {}

    // Getters et setters
    const std::wstring& GetPath() const { return m_path; }
    void SetPath(const std::wstring& path) { m_path = path; }

private:
    std::wstring m_path;
};

} // namespace ecs
